Package: org.codehaus.groovy.runtime

## [Java] Class CurriedClosure<V>

- org.codehaus.groovy.runtime.CurriedClosure

-     public final class CurriedClosure<V>
      extends Closure

  A wrapper for Closure to support currying. Normally used only internally through the `curry()`, `rcurry()` or `ncurry()` methods on `Closure`.

  Typical usages:

       // normal usage
       def unitAdder = { first, second, unit -> "${first + second} $unit" }
       assert unitAdder(10, 15, "minutes") == "25 minutes"
       assert unitAdder.curry(60)(15, "minutes") == "75 minutes"
       def minuteAdder = unitAdder.rcurry("minutes")
       assert minuteAdder(15, 60) == "75 minutes"

       // explicit creation
       import org.codehaus.groovy.runtime.CurriedClosure
       assert new CurriedClosure(unitAdder, 45)(15, "minutes") == "60 minutes"
       assert new CurriedClosure(unitAdder, "six", "ty")("minutes") == "sixty minutes"

  Notes:
  - Caters for Groovy's lazy (rcurry) and eager (ncurry) calculation of argument position

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class Closure` | `DELEGATE_FIRST, DELEGATE_ONLY, DONE, IDENTITY, OWNER_FIRST, OWNER_ONLY, TO_SELF, maximumNumberOfParameters, parameterTypes`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CurriedClosure(int index, Closure<V> uncurriedClosure, Object arguments)` Parameters: `index` - the position where the parameters should be injected (-ve for lazy)
    `CurriedClosure(Closure<V> uncurriedClosure, Object arguments)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public Object` | `clone()`
    `` | `public Object` | `getDelegate()`
    `` | `public Closure<V>` | `getOwner()`
    `` | `public Class[]` | `getParameterTypes()`
    `` | `public int` | `getResolveStrategy()`
    `` | `public Object[]` | `getUncurriedArguments(Object arguments)`
    `` | `public void` | `setDelegate(Object delegate)`
    `` | `public void` | `setResolveStrategy(int resolveStrategy)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Closure` | `andThen, andThenSelf, andThenSelf, asWritable, call, call, call, clone, compose, composeSelf, composeSelf, curry, curry, dehydrate, doCall, getDelegate, getDirective, getMaximumNumberOfParameters, getOwner, getParameterTypes, getProperty, getResolveStrategy, getThisObject, isCase, leftShift, leftShift, memoize, memoizeAtLeast, memoizeAtMost, memoizeBetween, ncurry, ncurry, rcurry, rcurry, rehydrate, rightShift, run, setDelegate, setDirective, setProperty, setResolveStrategy, throwRuntimeException, trampoline, trampoline`
    `class GroovyObjectSupport` | `getMetaClass, setMetaClass`

- - ### Constructor Detail

    - #### public CurriedClosure(int index, Closure<V> uncurriedClosure, Object arguments)

      Parameters:
        `index` - the position where the parameters should be injected (-ve for lazy)
        `uncurriedClosure` - the closure to be called after the curried parameters are injected
        `arguments` - the supplied parameters

    - #### public CurriedClosure(Closure<V> uncurriedClosure, Object arguments)

  - ### Method Detail

    - #### @Override
      public Object clone()

    - #### @Override
      public Object getDelegate()

    - #### @Override
      @SuppressWarnings("unchecked")
      public Closure<V> getOwner()

    - #### @Override
      public Class[] getParameterTypes()

    - #### @Override
      public int getResolveStrategy()

    - #### public Object[] getUncurriedArguments(Object arguments)

    - #### @Override
      public void setDelegate(Object delegate)

    - #### @Override
      public void setResolveStrategy(int resolveStrategy)